# uwu-framework
## Unifying web utility Framework

## About
This framework was created for one main reason - unite two conceptions for manipulating data and template of page: ***declarative*** and ***imperative***

When we speak about declarative method, that means you just need to <b><i>declare</i></b> instructions for manipulating data, for example:

```
<div [innerHtml]="this.some_variable"></div>
```
You just need to say "**Please, bind this.some_variable to same variable in current controller**", and every change of variable this attribute will **change together**. It makes developent ***much easier***

In controller you just need to declare this variable, and that's it, everything works!
```
import { uwuController } from './core';

@uwuController({
    selector: "some",
    styles: [],
})
export class SomeController {
    some_variable = "Some stored variable";
}
```

## Examples

Example of using Tsx component in common component