import { Type, uwuControlConfig, uwuControllerType, uwuDeclaration, uwuInjectableType, uwuModuleConfig, uwuRoutesConfig, uwuTsxControlConfig, uwuTsxControllerType } from "./core.types";
export declare class uwuControllerManager {
    processPageByController(controller: uwuControllerType | uwuTsxControllerType, entryElement?: HTMLElement | null): [uwuControllerType | uwuTsxControllerType, HTMLElement];
    private processController;
    private processTsxController;
    private getTemplateContent;
    private parseHTMLContent;
    static getInjectableInstance(controller: uwuControllerType | uwuTsxControllerType, injectable: uwuInjectableType): any;
    private updateStyles;
}
export declare function declarationCheck(target: any, compareTo: uwuDeclaration): boolean;
export declare function uwuModule(config: uwuModuleConfig): Function;
export declare function uwuController(config: uwuControlConfig): Function;
export declare function uwuTsxController(config: uwuTsxControlConfig): Function;
export declare function Input(): (target: Object, propertyKey: PropertyKey) => void;
export declare function Inject<T>(obj: Type<any>): (target: any, key: PropertyKey) => void;
export declare function uwuRouter(config: uwuRoutesConfig): Function;
export declare function uwuInjectable(): Function;
declare global {
    interface Window {
        root: Type<any>;
    }
}
export declare class RouterService {
    navigate(path: string[]): void;
}
export declare function bootstrap<T>(module: Type<T>): void;
