import { uwuControllerType } from "./core.types";
/**
 * @interface CustomVariable uwuFor="const a of this.some_array"
 */
interface CustomVariable {
    /**
     * @param elementName text representation 'a'
     */
    elementName: string;
    /**
     * @param element as object as element of this.some_array
     */
    element: any;
    /**
     * @param elementAction must be performed after changing this attribute
     */
    elementAction: Function;
    /**
     * @param elementAction must be performed after changing this attribute
     */
    elementArray: Array<any>;
}
declare global {
    interface HTMLElement {
        guid?: string;
    }
    interface Text {
        guid?: string;
    }
}
export declare class BindingEngine {
    private controllerInstance;
    constructor(controllerInstance: uwuControllerType);
    getControllerBindedToNodes(controllerInstance: uwuControllerType, parentNode: HTMLElement): [uwuControllerType, HTMLElement];
    private processNode;
    private processNodeConstructionally;
    private importControllerByTag;
    private borderedWith;
    private withoutSpec;
    private scopeEval;
    private checkBindingWay;
    private bindBothWay;
    private bindInWay;
    private bindInWayInner;
    private bindOutWay;
    private bindTextOutPutWay;
    addBindingEventToAttribute(attribute_value: string, action: Function, elementToBind: HTMLElement | Text, controllerInstance?: uwuControllerType, customVariable?: CustomVariable | null): void;
    dispatchBindingEvent(controllerInstance: uwuControllerType, token: string, forceValue?: any): void;
    private getFunctionClearedAttributeValue;
    private getActionByAttribute;
}
export {};
