"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.uwuTsxRenderManager = void 0;
const createElement = (tag, props, ...children) => {
    if (typeof tag === "function")
        return tag(props, ...children);
    const element = document.createElement(tag);
    Object.entries(props || {}).forEach(([name, value]) => {
        if (name.startsWith("on") && name.toLowerCase() in window)
            element.addEventListener(name.toLowerCase().substr(2), value);
        else
            element.setAttribute(name, value.toString());
    });
    children.forEach(child => {
        appendChild(element, child);
    });
    return element;
};
const appendChild = (parent, child) => {
    if (Array.isArray(child))
        child.forEach(nestedChild => appendChild(parent, nestedChild));
    else
        parent.appendChild(child.nodeType ? child : document.createTextNode(child.toString()));
};
const createFragment = (props, ...children) => {
    return children;
};
// Global storage manager for redrawing an storaging components
class uwuTsxRenderManager {
    static render(guid, newState) {
        this.hooks[guid](newState);
    }
}
exports.uwuTsxRenderManager = uwuTsxRenderManager;
uwuTsxRenderManager.hooks = {};
const uwuTsx = {
    createElement,
};
exports.default = uwuTsx;
//# sourceMappingURL=core.enginetsx.js.map