export interface uwuModuleConfig {
    imports: Array<Type<any>>;
    exports: Array<Type<any>>;
}
export interface uwuControlConfig {
    template: string;
    selector: string;
    styles: string[];
}
export interface uwuTsxControlConfig {
    hook: (guid: string) => Function;
    selector: string;
    styles: string[];
}
export declare type Route = {
    path: string;
    children?: Array<Route>;
    target: uwuModuleType | uwuControllerType;
    guard?: any;
    /**
     * @param regexp whether should be found by regexp
     */
    regexp?: boolean;
};
export declare type uwuTsxElement = {
    hooks?: any;
    type?: string | Function;
    child?: uwuTsxElement | null;
    parent?: uwuTsxElement;
    alternate?: uwuTsxElement | null;
    sibling?: uwuTsxElement | null;
    effectTag?: "PLACEMENT" | "UPDATE" | "DELETION";
    dom?: HTMLElement | null;
    props: {
        [key: string]: any;
        children?: Array<uwuTsxElement>;
    };
};
export declare type HookFunction = {
    (): uwuTsxElement;
};
export interface uwuRoutesConfig {
    routes: Array<Route>;
}
export declare enum uwuDeclaration {
    Module = 0,
    Controller = 1,
    ControllerTsx = 2,
    Injectable = 3,
    Router = 4
}
export declare type uwuModuleType = Type<any>;
export declare type uwuControllerType = Type<any>;
export declare type uwuTsxControllerType = Type<any>;
export declare type uwuInjectableType = Type<any>;
export declare type uwuRouterType = Type<any>;
interface FunctionConstructor {
    /**
     * Creates a new function.
     * @param args A list of arguments the function accepts.
     */
    new (...args: string[]): Function;
    (...args: string[]): Function;
    readonly prototype: Function;
}
export declare const Type: FunctionConstructor;
export interface Type<T> extends Function {
    new (...args: any[]): T;
    [key: string]: any;
}
export interface parsedUrl {
    url: URL;
    params: Object;
    path_raw: string;
    path: string[];
}
export declare type bindPackType = {
    [guid: string]: {
        descriptor?: PropertyDescriptor;
        actions: {
            [key: string]: Function;
        };
        forceValue?: string;
    };
};
export {};
