"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.observeArray = exports.observe = exports.guid = exports.isObject = exports.parseQuery = void 0;
function parseQuery(query) {
    let variables = query.substring(1).split('&');
    let result = {};
    variables.forEach(element => {
        let pair = element.split('=');
        if (pair.length > 0) {
            result[pair[0]] = pair[1];
        }
    });
    return result;
}
exports.parseQuery = parseQuery;
function isObject(variable) {
    return (typeof variable === 'object' &&
        !Array.isArray(variable) &&
        variable !== null);
}
exports.isObject = isObject;
function guid() {
    // 00000000-0000-0000-0000-000000000000
    function f() {
        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1).toUpperCase();
    }
    return `${f()}${f()}-${f()}-${f()}-${f()}-${f()}${f()}${f()}`;
}
exports.guid = guid;
;
// function watch(value: any, name: any) {
//     // create handler for proxy
//     const handler = new Proxy({
//         apply(target: any, thisArg: any, argsList: any) : any[] {
//             // something was invoked, so return custom array
//             return [value, name, receiver, argsList];
//         },
//         get(target: any, property: PropertyKey) : any {
//             // a property was accessed, so wrap it in a proxy if possible
//             const {
//                 writable,
//                 configurable
//             } = Object.getOwnPropertyDescriptor(target, property) || { configurable: true };
//             return writable || configurable
//                 ? watch(value === object ? value[property.toString()] : undefined, property)
//                 : target[property.toString()];
//         }
//     }, {
//         get(handler : any, trap : any) {
//             if (trap in handler) {
//                 return handler[trap];
//             }
//             // reflect intercepted traps as if operating on original value
//             return (target: any, ...args: any) => (Reflect as any)[trap].call(handler, value, ...args);
//         }
//     });
//     // coerce to object if value is primitive
//     const object = Object(value);
//     // create callable target without any own properties
//     const target = () => { };
//     target.length = 0;
//     target.name = '';
//     // set target to deep clone of object
//     Object.setPrototypeOf(
//         Object.defineProperties(target, Object.getOwnPropertyDescriptors(object)),
//         Object.getPrototypeOf(object)
//     );
//     // create proxy of target
//     const receiver = new Proxy(target, handler);
//     return receiver;
// }
function observe(obj, fn) {
    return new Proxy(obj, {
        set(obj, key, val) {
            obj[key] = val;
            fn(obj);
            return true;
        },
        get(target, p, reciever) {
            console.log(target, p, reciever);
            return Reflect.get(target, p, reciever);
        }
    });
}
exports.observe = observe;
;
function observeArray(obj, action) {
    const push = obj.push.bind(obj);
    obj.push = (...args) => {
        const res = push(...args);
        action(obj);
        return res;
    };
    const slice = obj.slice.bind(obj);
    obj.slice = (...args) => {
        const res = slice(...args);
        action(obj);
        return res;
    };
    const shift = obj.shift.bind(obj);
    obj.shift = () => {
        const res = shift();
        action(obj);
        return res;
    };
    const pop = obj.pop.bind(obj);
    obj.pop = () => {
        const res = pop();
        action(obj);
        return res;
    };
    return observe(obj, action);
}
exports.observeArray = observeArray;
//# sourceMappingURL=funcs.js.map